const React = require("react");

const SwitchThemeContext = React.createContext(["", () => {}]);

exports.SwitchThemeContext = SwitchThemeContext;

const useSwitchTheme = () => React.useContext(SwitchThemeContext);

exports.useSwitchTheme = useSwitchTheme;

const SwitchThemeProvider = ({ themes, defaultTheme }) => {
  const [themeKey, setThemeKey] = React.useState(defaultTheme);

  const contextValue = React.useMemo(() => [themeKey, setThemeKey]);

  return (
    <SwitchThemeContext.Provider value={contextValue}>
      <ThemeContext.Provider value={themes[themeKey]}>
        {children}
      </ThemeContext.Provider>
    </SwitchThemeContext.Provider>
  );
};

exports.SwitchThemeProvider = SwitchThemeProvider;
